Bug 1123011 - Review Request: python-dockerpty - Python library to use the pseudo-tty of a docker container
Summary: Review Request: python-dockerpty - Python library to use the pseudo-tty of a ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Julien Enselme
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-24 15:25 UTC by Adam Miller
Modified: 2015-01-11 13:30 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-01-11 13:30:37 UTC
jujens: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Adam Miller 2014-07-24 15:25:42 UTC
Spec URL: http://maxamillion.fedorapeople.org/python-dockerpty.spec
SRPM URL: http://maxamillion.fedorapeople.org/python-dockerpty-0.2.1-1.fc20.src.rpm
Description: 
Provides the functionality needed to operate the pseudo-tty (PTY) allocated to
a docker container, using the Python client.

Fedora Account System Username: maxamillion

Comment 1 Julien Enselme 2014-08-03 12:41:55 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[X]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)". Detailed output of licensecheck in
     /run/media/jenselme/Data/1123011-python-dockerpty/licensecheck.txt
[X] : License file installed when any subpackage combination is installed.
[X]: %build honors applicable compiler flags or justifies otherwise.
[X]: Package contains no bundled libraries without FPC exception.
[X]: Changelog in prescribed format.
[X]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[*]: Development files must be in a -devel package
[X]: Package uses nothing in %doc for runtime.
[X]: Package consistently uses macros (instead of hard-coded directory names).
[X]: Package is named according to the Package Naming Guidelines.
[X]: Package does not generate any conflict.
[X]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[X]: Requires correct, justified where necessary.
[X]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.
[X]: Package is not known to require an ExcludeArch tag.
[X]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 10 files.
[X]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[X]: Python eggs must not download any dependencies during the build process.
[ X: A package which is used by another package via an egg interface should
     provide egg info.
[X]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-dockerpty
[X]: Package functions as described.
[X]: Latest version is packaged.
[X]: Package does not include license text files separate from upstream.
[X]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: Package should compile and build into binary rpms on all supported
     architectures.
[X]: %check is present and all tests pass.
[X]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-dockerpty-0.2.1-1.fc20.x86_64.rpm
          python3-dockerpty-0.2.1-1.fc20.x86_64.rpm
          python-dockerpty-0.2.1-1.fc20.src.rpm
python-dockerpty.x86_64: W: spelling-error Summary(en_US) tty -> try, ttys, atty
python-dockerpty.x86_64: W: spelling-error %description -l en_US tty -> try, ttys, atty
python-dockerpty.x86_64: E: no-binary
python3-dockerpty.x86_64: W: summary-ended-with-dot C Python module to generate a formatted text table, using ASCII characters.
python-dockerpty.src: W: spelling-error Summary(en_US) tty -> try, ttys, atty
python-dockerpty.src: W: spelling-error %description -l en_US tty -> try, ttys, atty
python-dockerpty.src:35: W: mixed-use-of-spaces-and-tabs (spaces: line 35, tab: line 9)
3 packages and 0 specfiles checked; 1 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-dockerpty python3-dockerpty
python-dockerpty.x86_64: W: spelling-error Summary(en_US) tty -> try, ttys, atty
python-dockerpty.x86_64: W: spelling-error %description -l en_US tty -> try, ttys, atty
python-dockerpty.x86_64: E: no-binary
python3-dockerpty.x86_64: W:   C Python module to generate a formatted text table, using ASCII characters.
2 packages and 0 specfiles checked; 1 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-dockerpty (rpmlib, GLIBC filtered):
    python(abi)

python3-dockerpty (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python-dockerpty:
    python-dockerpty
    python-dockerpty(x86-64)

python3-dockerpty:
    python3-dockerpty
    python3-dockerpty(x86-64)



Source checksums
----------------
https://pypi.python.org/packages/source/d/dockerpty/dockerpty-0.2.1.tar.gz :
  CHECKSUM(SHA256) this package     : fe850bcb72a436d07c1daef1c642dad04c1fb4d09b76ad2dc55e0dbd499beb84
  CHECKSUM(SHA256) upstream package : fe850bcb72a436d07c1daef1c642dad04c1fb4d09b76ad2dc55e0dbd499beb84


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1123011
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Please use:
- the %{__python2} macro for python2.
- the %{python2_sitelib} macro instead of %{python_sitelib}
- BuildArch:      noarch

Please correct the summary-ended-with-dot and mixed-use-of-spaces-and-tabs warnings.

I guess you made a wrong copy/paste in the python3 summary and description.

Comment 2 Adam Miller 2014-08-08 23:32:39 UTC

Spec URL: http://maxamillion.fedorapeople.org/python-dockerpty.spec
SRPM URL: https://maxamillion.fedorapeople.org/python-dockerpty-0.2.1-2.fc20.src.rpm

I fixed up the notes that were made, however instead of listing it as "BuildArch: noarch" I actually listed it "ExclusiveArch: x86_64" because this is meant to be used with docker containers and docker itself is "ExclusiveArch: x86_64". I also made a note in a spec file for posterity.

Thank you,
-AdamM

Comment 3 Julien Enselme 2014-08-09 09:17:38 UTC
The python3 summary is still incorrect.

According to https://fedoraproject.org/wiki/Packaging:Python#Files_to_include you can use:
%files
%{python2_sitelib}/foo/ (I forget the last / sorry)

or

%files
%dir %{python2_sitelib}/foo (to add the directory)
%{python2_sitelib}/foo/*

Please add
%dir %{python2_sitelib}/dockerpty
%{python2_sitelib}/dockerpty/*
%dir %{python2_sitelib}/dockerpty-0.2.1-py3.3.egg-info
%{python2_sitelib}/dockerpty-0.2.1-py3.3.egg-info/*

Idem for python3.

> I fixed up the notes that were made, however instead of listing it as "BuildArch: noarch" I actually listed it "ExclusiveArch: x86_64" because this is meant to be used with docker containers and docker itself is "ExclusiveArch: x86_64". I also made a note in a spec file for posterity.

Except that your python package does not contain any architecture specific source and so has no binary. Hence the no-binary error from rmplint. So, as stated here: https://fedoraproject.org/wiki/Common_Rpmlint_issues#no-binary it must be of noarch. By doing so, you get rid of the unseful debuginfo package and the rpmlint error.

If the only way to use this package is with docker, add docker as a dependency. Your package then won't install on an architecture that is not supported by docker.

Comment 4 Adam Miller 2014-08-11 18:46:26 UTC
Spec URL: http://maxamillion.fedorapeople.org/python-dockerpty.spec
SRPM URL: https://maxamillion.fedorapeople.org/python-dockerpty-0.2.1-3.fc20.src.rpm

Updated based on comments, looking forward to further review. I think I have all issues resolved at this time.

Thank you,
-AdamM

Comment 5 Julien Enselme 2014-08-12 09:28:04 UTC
dockerpty-0.2.1-py3.3.egg-info and dockerpty-0.2.1-py2.7.egg-info are folder. Please add them like the dockerpty folder.

I still think that you should use BuildArch: noarch.

Comment 6 Adam Miller 2014-08-12 14:04:55 UTC
Spec URL: http://maxamillion.fedorapeople.org/python-dockerpty.spec
SRPM URL: https://maxamillion.fedorapeople.org/python-dockerpty-0.2.1-4.fc20.src.rpm

I've updated both the %files section and BuildArch based on feedback.

Comment 7 Julien Enselme 2014-08-12 16:02:04 UTC
Approved!

Comment 8 Adam Miller 2014-08-12 16:31:07 UTC
New Package SCM Request
=======================
Package Name: python-dockerpty
Short Description: Python library to use the pseudo-tty of a docker container
Upstream URL: https://github.com/d11wtq/dockerpty
Owners: maxamillion
Branches: f20 f21

Comment 9 Gwyn Ciesla 2014-08-12 19:19:55 UTC
Git done (by process-git-requests).

Comment 10 Julien Enselme 2014-11-26 14:10:27 UTC
This package is in testing since 3 month without negative karma. Maybe you can push it to the stable repository and close this review?

Comment 11 Julien Enselme 2015-01-11 13:30:37 UTC
This package has been pushed to stable: https://admin.fedoraproject.org/updates/FEDORA-2014-9732/python-dockerpty-0.2.3-1.fc20.

Closing this review.


Note You need to log in before you can comment on or make changes to this bug.